
fn getPointDir viewPoint worldPoint gridPoint currentNode=
(
				box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
				arr= (boxPickNode box)
				wpt= worldPoint
				
				n=0
				minDist= 10000
				minPt= gridPoint+[0,0,0.2]
				minDir= [0,1,0]
				for node in arr do
				(
					if (currentNode!=node) and (SuperClassOf node == shape) then
					 if  ((getUserProp node "Type")=="normal") or ((getUserProp node "Type")=="switch") then
					  (
						print (getUserProp node "Type")
						convertToSplineShape node
						for i=1 to (numSplines node) do
						(
							nk= (numKnots node i)
							
							pt= getKnotPoint node i 1
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i 1)==#line) then
									minDir= pt - (getKnotPoint node i 2)
								else
									minDir= pt - (getOutVec node i 1)
								
							)

							pt= getKnotPoint node i nk
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i (nk-1))==#line) then
									minDir= pt - (getKnotPoint node i (nk-1))
								else
									minDir= pt - (getInVec node i nk)
							)

						)
					  )
				)
				minDir= (normalize minDir)
				#(minPt,minDir)
)

fn AddNewTrack minPt minDir type nodeName length direction radius totalangle trackslope =
(
	disableSceneRedraw()
				if (type==1) then
				(
					l= line name:nodeName pos:minPt	
					minDir.z= 0
					addNewSpline l
					addKnot l 1 #smooth #line minPt
					addKnot l 1 #smooth #line (minPt+minDir*length+[0,0,trackslope*length/1000])
					updateShape l
					track= l
				)
				else
				(
					vec= normalize (cross z_axis minDir)
					if (direction==2) then 
						pt= minPt-vec*radius
					else
						pt= minPt+vec*radius
					dir= minDir
--					dir.z=0
					dir= normalize dir
					if (dir.x!=0) then
						angle= atan (dir.y/dir.x)
					else
						if (dir.y>0) then
							angle= 90
						else
							angle= -90
					if (dir.x<0) then
						if (dir.y<0) then
							angle= angle-180
						else
							angle= 180+angle
					Format "angle: %\n" angle
					if (totalangle>0) then
						ang= totalangle*3
					else
						ang= (length*180*3)/(pi*radius)
					if (ang>270) then
						ang= 270
					if (direction==2) then 
					(
						ato= angle+90
						afrom= ato-ang
					)
					else
					(
						afrom= angle-90 
						ato= afrom+ang
					)
					
					if (afrom<0) then
					(
						afrom= afrom+360
					)
					if (ato<0) then
						ato= ato+360
					if (ato>360) then
						ato= ato-360
					print afrom
					print ato
					print radius
					a= arc name:nodeName pos:pt radius:radius from:afrom to:ato
					convertToSplineShape a
					if (direction==1) then 
					(
						deleteKnot a 1 (numKnots a 1)
						deleteKnot a 1 (numKnots a 1)
						updateShape a
					)
					else
					(
						deleteKnot a 1 1
						deleteKnot a 1 1
						reverse a 1
						updateShape a
						
					)
					track= a
					
				)
	enableSceneRedraw()
	
	return track
)

fn AddFlexTrack minPt minDir nodeName minPt2 minDir2 =
(
	disableSceneRedraw()
	l= line name:nodeName pos:minPt
	len= (distance  minPt minPt2)/3
	addNewSpline l
	addKnot l 1 #bezier #curve minPt minPt (minPt+minDir*len)
	addKnot l 1 #bezier #curve minPt2 (minPt2+minDir2*len) minPt2
	updateShape l
	track= l
	enableSceneRedraw()
	
	return track
)


fn createPods splObj minPrecision PHeight PBase PWidthC PWidthB material texLen = 
(
	h1= PBase
	h2= PHeight
	w1= PWidthB
	w2= PWidthC
	tu1= 0
	tu2= 0.5*((w1-w2)/w1)
	tu3= 1-0.5*((w1-w2)/w1)
	tu4= 1

	lenArray= getSegLengths splObj 1
	len= lenArray[2]
	numSegs= ((len/minPrecision) as integer ) as float
	v1= tangentCurve3d splObj 1 0
	p1= interpCurve3d splObj 1 0
	if (numSegs<1) then
		numSegs= 1
--	obj= (mesh pos:p1 length:len width:2 lengthsegs:numSegs widthsegs:3)
	verts= #()
	tvertices= #()
	fcs= #()
	for i=0 to numSegs do
	(
		v1= tangentCurve3d splObj 1 (((i as float)/numSegs))
		p1= interpCurve3d splObj 1 (((i as float)/numSegs))
		v1side= (cross v1 z_axis)
		verts[(i)*4+1]= p1+(v1side*w1)+(point3 0 0 h1)
		verts[(i)*4+2]= p1+(v1side*w2)+(point3 0 0 h2)
		verts[(i)*4+3]= p1-(v1side*w2)+(point3 0 0 h2)
		verts[(i)*4+4]= p1-(v1side*w1)+(point3 0 0 h1)
		
		tv= (len/texLen)*((i as float)/numSegs)
		tvertices[(i)*4+1]= (point3 tu1 tv 0)
		tvertices[(i)*4+2]= (point3 tu2 tv 0)
		tvertices[(i)*4+3]= (point3 tu3 tv 0)
		tvertices[(i)*4+4]= (point3 tu4 tv 0)

	)
	for i=1 to numSegs do
	(
		fcs[(i-1)*6+1]= (point3 ((i-1)*4+1) ((i)*4+1) ((i-1)*4+2) )
		fcs[(i-1)*6+2]= (point3 ((i-1)*4+2) ((i)*4+1) ((i)*4+2) )
		fcs[(i-1)*6+3]= (point3 ((i-1)*4+2) ((i)*4+2) ((i-1)*4+3) )
		fcs[(i-1)*6+4]= (point3 ((i-1)*4+3) ((i)*4+2) ((i)*4+3) )
		fcs[(i-1)*6+5]= (point3 ((i-1)*4+3) ((i)*4+3) ((i-1)*4+4) )
		fcs[(i-1)*6+6]= (point3 ((i-1)*4+4) ((i)*4+3) ((i)*4+4) )
		
	)
	
	disableSceneRedraw()
	obj= (mesh vertices:verts faces:fcs tverts:tvertices material:material)
	for i=1 to obj.numFaces do
	(
		mod= i-((i-1)/6)*6
		if (mod<3 or mod>4) then
			setFaceSmoothGroup obj i 1
		else
			setFaceSmoothGroup obj i 2
	)
	obj.wireColor= (color 32 32 156)
	buildTVFaces obj
	for f = 1 to obj.numfaces do 
	setTVFace obj f (getface obj f) 

	update obj
	enableSceneRedraw()
	
)

fn shapeFilt o = superClassOf o == Shape 

rollout CreateNormalTrack "Create Normal Track"
(
	local tr
	editText eName "Name" text:"" 
	radioButtons rbType "Type" labels:#(#Line, #Arc, #Flex) align:#left
	radioButtons rbDirection "Direction" labels:#(#Left, #Right) enabled:false align:#left
	spinner spnRoll1 "Roll 1" range:[-45,45,0] align:#left
	spinner spnRoll2 "Roll 2" range:[-45,45,0] align:#left
	spinner spnLength "Length" range:[0.2,500,100] align:#left
	spinner spnRadius "Radius" range:[10,2000,300] enabled:false align:#left
	spinner spnAngle "Angle" range:[0,90,45] enabled:false align:#left
	spinner spnSlope "Slope/1000" range:[-50,50,0] align:#left

	editText eMaxdist "MaxDistance" text:"-1" 
	editText eMindist "MinDistance" text:"0" across:2
	editText eParam1 "TrackWidth" text:"1.435" 
	editText eParam2 "Friction" text:"0.25" 
	editText eParam3 "SoundDist" text:"25.0" 
	editText eParam4 "Quality" text:"20" 
	editText eParam5 "DamageFlag" text:"0" 
	radioButtons rbEnvironment "Environment" labels:#(#Flat, #Bank, #Bridge, #Mountains, #Canyon, #Tunnel) align:#left columns:3
--	editText eParam6 "Environment" text:"flat" 
	editText eParam7 "Visibility" text:"vis" 
	editText eParam8 "Tex1" text:"Rail_screw_used1" 
	editText eParam9 "TexLength" text:"4" 
	editText eParam10 "Tex2" text:"TpBpS-new2.tex" 
	editText eParam11 "TexHeight" text:"0.2" 
	editText eParam12 "TexWidth" text:"0.5" 
	editText eParam13 "TexSlope" text:"1.1" 
	editText eEvent0 "Event0" text:""
	editText eEvent1 "Event1" text:""
	editText eEvent2 "Event2" text:""
	spinner spnVelocity "Velocity" range:[-1,500,-1] scale:1 type:#float align:#left
	button btn1 "Create"
	button btn1add "Add to previous" enabled:false
	
	label lab1 "___________________________________"
	label lab2 "/\"\"\"\"\\"
	spinner spnPods "Segm Len" range:[5,100,5] scale:1 type:#float fieldwidth:30 
	spinner spnPodsH "CroneHeight" range:[-2,2,0.0] scale:0.1 type:#float fieldwidth:35 across:2
	spinner spnPodsB "BaseHeight" range:[-20,20,-10] scale:1 type:#float fieldwidth:35 
	spinner spnPodsWC "Crone Width" range:[1,10,2] scale:0.1 type:#float fieldwidth:35 across:2
	spinner spnPodsWB "Base Width" range:[2,50,22] scale:0.1 type:#float fieldwidth:35 
	materialbutton mbTrackMat "Material" 
	spinner spnTexLen "Tex Len" range:[1,1000,4] scale:1 type:#float
	pickbutton btn0 "Create" filter:shapeFilt

	fn fixLength= 
	(
		l= curveLength tr
		print l
		if (l>100) then
		(
			n= ceil (l/100)
			print n
			subdivideSegment tr 1 1 (n-1)
			newl = l/n
			setUserProp tr "Length" (newl as string)
			updateShape tr
			for i=1 to n-1 do
			(
				spl= copy tr
				spl.name= tr.name
				setUserPropBuffer spl (getUserPropBuffer tr)
				j=(numKnots spl 1)
				while (j>=1) do
				(
					if (j!=i and j!=i+1) then
						deleteKnot spl 1 j
					j-= 1
				)
				spl.wireColor= (color 8 8 136)
				updateShape spl
				l= curveLength spl
				print l
			)
			j=(numKnots tr 1)
			while (j>=1) do
			(
				if (j!=n and j!=n+1) then
					deleteKnot tr 1 j
				j-= 1
			)
			tr.wireColor= (color 8 8 128)
			updateShape tr
--			delete tr
			print "fixed"
			print tr
		)
		 else
			setUserProp tr "Length" (l as string)
	)

	tool CreateTrack
	( 
		local nodeName
		local Pt1,Dir1
--		local tr
                local r1= spnRadius.value
		on mousePoint clickno do 
			if clickno != 2 then
			(
				if (eName.text=="") then
					nodeName= "none"
				else
					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
					else
						nodeName= uniqueName eName.text
				print clickno
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
                                if (rbType.state==2) then
				(
				 if (rbDirection.state==2) then
				 (
  				   r1= -r1
				 )
				)
				else
				(
  				 r1= 0
				)

				if (rbType.state==3) then
				(
					Pt1= ptArr[1]
					Dir1= ptArr[2]
                                        spnSlope.value= 0
					tr= (AddFlexTrack Pt1 Dir1 (nodeName) Pt1 Dir1)
				)
				else
				(
					tr= (AddNewTrack ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value spnSlope.value)
				)
				setUserProp tr "Type" "normal"
				setUserProp tr "Radius1" (r1 as string)
				setUserProp tr "Roll1" (spnRoll1.value as string)
				setUserProp tr "Roll2" (spnRoll2.value as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
--				setUserProp tr "Environment" eParam6.text
				case rbEnvironment.state of
				 (
				  1:
				   (
				     setUserProp tr "Environment" "Flat"
				   )
				  2:
				   (
				     setUserProp tr "Environment" "Bank"
				   )
				  3:
				   (
				     setUserProp tr "Environment" "Bridge"
				   )
				  4:
				   (
				     setUserProp tr "Environment" "Mountains"
				   )
				  5:
				   (
				     setUserProp tr "Environment" "Canyon"
				   )
				  6:
				   (
				     setUserProp tr "Environment" "Tunnel"
				   )
				 )				
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" eParam10.text
				setUserProp tr "TexPar1" eParam11.text
				setUserProp tr "TexPar2" eParam12.text
				setUserProp tr "TexPar3" eParam13.text
				if (eEvent0.text!="") then
					setUserProp tr "Event0" eEvent0.text
				if (eEvent1.text!="") then
					setUserProp tr "Event1" eEvent1.text
				if (eEvent2.text!="") then
					setUserProp tr "Event2" eEvent2.text
				if (spnVelocity.value>=0) then
				(
					setUserProp tr "Velocity" (spnVelocity.value as string)
				)
				tr.wireColor= (color 8 8 136)
				fixLength()
			)
			else
				if (rbType.state==3) then
					#stop

		on mouseMove clickno do
		(
			if (rbType.state==3) then
			(
				ptArr= (getPointDir viewPoint worldPoint gridPoint tr)
				len= (distance Pt1 ptArr[1])/3
				setKnotPoint tr 1 2 ptArr[1]
				setInVec tr 1 2 (ptArr[1]+ptArr[2]*len)
				setOutVec tr 1 2 ptArr[1]
				setOutVec tr 1 1 (Pt1+Dir1*len)
				updateShape tr
--				fixLength()
			)
		)
	) 
--createtrack
	fn AddTrack =
	( 
		local newtr
		local nodeName
		local Pt1,Dir1
      	local r1= spnRadius.value
		if (eName.text=="") then
			nodeName= "none"
		else
		 if (getNodeByName eName.text)==undefined then
			nodeName= eName.text
		 else
		  nodeName= uniqueName eName.text
        	if (rbType.state==2) then
		(
		 if (rbDirection.state==2) then
		 (
		  r1= -r1
		 )
		)
		else
		(
		 r1= 0
		)
				minPt= [0,0,0.2]
				minDir= [0,1,0]
				convertToSplineShape tr
				minPt= getKnotPoint tr 1 2
				if ((getSegmentType tr 1 1)==#line) then
					minDir= minPt - (getKnotPoint tr 1 1)
				else
					minDir= minPt - (getInVec tr 1 2)							
				minDir= (normalize minDir)
				print minPt
				print minDir

		newtr= (AddNewTrack minPt minDir rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value spnSlope.value)
	
		setUserProp newtr "Type" "normal"
--		setUserProp newtr "Length" (spnLength.value as string)
		setUserProp newtr "Radius1" (r1 as string)
		setUserProp newtr "Roll1" (spnRoll1.value as string)
		setUserProp newtr "Roll2" (spnRoll2.value as string)
		setUserProp newtr "MaxDist" eMaxdist.text
		setUserProp newtr "MinDist" eMindist.text
		setUserProp newtr "TrackWidth" eParam1.text
		setUserProp newtr "Friction" eParam2.text
		setUserProp newtr "SoundDist" eParam3.text
		setUserProp newtr "Quality" eParam4.text
		setUserProp newtr "DamageFlag" eParam5.text
		case rbEnvironment.state of
		 (
		  1:
		   (
		     setUserProp newtr "Environment" "Flat"
		   )
		  2:
		   (
		     setUserProp newtr "Environment" "Bank"
		   )
		  3:
		   (
		     setUserProp newtr "Environment" "Bridge"
		   )
		  4:
		   (
		     setUserProp newtr "Environment" "Mountains"
		   )
		  5:
		   (
		     setUserProp newtr "Environment" "Canyon"
		   )
		  6:
		   (
		     setUserProp newtr "Environment" "Tunnel"
		   )
		 )				
		setUserProp newtr "Visibility" eParam7.text
		setUserProp newtr "Tex1" eParam8.text
		setUserProp newtr "TexLength" eParam9.text
		setUserProp newtr "Tex2" eParam10.text
		setUserProp newtr "TexPar1" eParam11.text
		setUserProp newtr "TexPar2" eParam12.text
		setUserProp newtr "TexPar3" eParam13.text
		if (eEvent0.text!="") then
			setUserProp newtr "Event0" eEvent0.text
		if (eEvent1.text!="") then
			setUserProp newtr "Event1" eEvent1.text
		if (eEvent2.text!="") then
			setUserProp newtr "Event2" eEvent2.text
		if (spnVelocity.value>=0) then
		(
			setUserProp newtr "Velocity" (spnVelocity.value as string)
		)
		newtr.wireColor= (color 8 8 146)
	return newtr
	) 
--addtrack

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnLength.enabled= true
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
				spnSlope.enabled= true
			)
			2:
			(
				spnLength.enabled= true
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
				spnSlope.enabled= false
			)
			3:
			(
				spnLength.enabled= false
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
				spnSlope.enabled= false
			)
		)
	)

	on btn0 picked obj do
	(
		createPods obj spnPods.value spnPodsH.value spnPodsB.value spnPodsWC.value spnPodsWB.value mbTrackMat.material spnTexLen.value
	)
	on btn1 pressed do
	(
		startTool CreateTrack
		btn1add.enabled= true
	)
	on btn1add pressed do
	(
		if (rbType.state!=3) then
		 (
			if tr!=undefined and not (isDeleted tr) then
			(
	 			tr = AddTrack()
				fixLength()
			)
			else
				btn1add.enabled=false
		 )
	)
	on spnAngle changed value do
	     spnLength.value= spnRadius.value*spnAngle.value*pi/180
	on spnRadius changed value do
	     spnLength.value= spnRadius.value*spnAngle.value*pi/180
	on spnLength changed value do
          if (rbType.state==2) then
	     spnAngle.value= spnLength.value*180/(spnRadius.value*pi)
)


rollout CreateSwitch "Create Switch"
(
	editText eName "Name" text:"Test_zwr01" 
--	spinner spnState "State" range:[0,1,0] type:#integer align:#left
	radioButtons rbType "Type" labels:#(#Line, #Arc) align:#left
--	radioButtons rbType2 "Type 2" labels:#(#Line, #Arc) default:2 align:#left
	radioButtons rbDirection "Direction" labels:#(#Left, #Right) align:#left
	spinner spnLength "Length" range:[1,100,34] align:#left
	spinner spnRadius1 "Radius 1" range:[100,1200,300] enabled:false align:#left
	spinner spnRadius2 "Radius 2" range:[100,1200,300] align:#left
	editText eFileName "Ctrl. Include File" text:"ZwrL34R300.inc" 
	editText eTexture "Include Texture" text:"zwrot34R300pods-new.tex" 
	
	editText eMaxdist "MaxDistance" text:"-1" 
	editText eMindist "MinDistance" text:"0" 
	editText eParam1 "TrackWidth" text:"1.435" 
	editText eParam2 "Friction" text:"0.24" 
	editText eParam3 "SoundDist" text:"15.0" 
	editText eParam4 "Quality" text:"20" 
	editText eParam5 "DamageFlag" text:"2" 
	editText eParam6 "Environment" text:"flat" 
	editText eParam7 "Visibility" text:"vis" 
	editText eParam8 "Tex1" text:"Rail_screw_used1" 
	editText eParam9 "TexLength" text:"4" 
	editText eParam10 "Tex2" text:"Rail_screw_used1" 
	editText eParam11 "TP1" text:"0.2" fieldwidth:30 across:3
	editText eParam12 "TP2" text:"2.75" fieldwidth:30 
	editText eParam13 "TP3" text:"2.5" fieldwidth:30 
	
--	editText eEvent0 "Event0" text:""
--	editText eEvent1 "Event1" text:""
--	editText eEvent2 "Event2" text:""
	spinner spnVelocity "Velocity" range:[-1,500,-1] scale:1 type:#float align:#left
	button btn1 "Create"
	
	tool CreateTrack
	( 
		local a
		local r2= spnRadius1.value
		local nodeName
                local r= spnRadius2.value
		local swrot= 0
		local zvec
		local swpos
		on mousePoint clickno do 
			if clickno == 1 then
			(
				if (eName.text=="") then
					nodeName= "none"
				else
					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
					else
						nodeName= uniqueName eName.text
				
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
				if (rbType.state==2 and spnRadius1.value==spnRadius2.value) then
                                    (
-- rozjazd symetryczny
					t1= (AddNewTrack ptArr[1] ptArr[2] 2 (nodeName) spnLength.value 1 spnRadius1.value 0 0)
					t2= (AddNewTrack ptArr[1] ptArr[2] 2 (nodeName) spnLength.value 2 spnRadius2.value 0 0)
					r= spnRadius2.value;
					r= -spnRadius1.value
				    )                                	
				else
				 (
				  if (rbDirection.state==1) then
                                    (
					t1= (AddNewTrack ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius1.value 0 0)
					t2= (AddNewTrack ptArr[1] ptArr[2] 2            (nodeName) spnLength.value rbDirection.state spnRadius2.value 0 0)
					if rbType.state==1 then
					 r= 0
					else
					 r= spnRadius2.value
					r2= spnRadius1.value
				    )			  
				   else
				    (
					t1= (AddNewTrack ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius1.value 0 0)
					t2= (AddNewTrack ptArr[1] ptArr[2] 2            (nodeName) spnLength.value rbDirection.state spnRadius2.value 0 0)
					if rbType.state==1 then
					 r= 0
					else
					 r= -spnRadius2.value
					r2= -spnRadius1.value
				    )
				 )
				addAndWeld t1 t2 -1
				tr= t1
				setUserProp tr "Type" "switch"
--				setUserProp tr "State" (spnState.value as string)			
				setUserProp tr "Length" (spnLength.value as string)
				setUserProp tr "Roll1" "0.1"
				setUserProp tr "Roll2" "-0.1"
				setUserProp tr "Radius1" (r as string)
				setUserProp tr "Radius2" (r2 as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
				setUserProp tr "Environment" eParam6.text
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" eParam10.text
				setUserProp tr "TexPar1" eParam11.text 
				setUserProp tr "TexPar2" eParam12.text 
				setUserProp tr "TexPar3" eParam13.text 
--				if (eEvent0.text!="") then
--					setUserProp tr "Event0" eEvent0.text
--				if (eEvent1.text!="") then
--					setUserProp tr "Event1" eEvent1.text
--				if (eEvent2.text!="") then
--					setUserProp tr "Event2" eEvent1.text
				if (spnVelocity.value>=0) then
				(
					setUserProp tr "Velocity" (spnVelocity.value as string)
				)

				tr.wireColor= (color 87 224 87)	
-- .inc dla zwrotnicy
				str="include;"+eFileName.text+";%;%;%;%;%;"+eTexture.text+";end"
				setUserProp tr "ExportString" str

				#stop 
			)
	) 
	on rbDirection changed state do
	(
		case state of
		(
			1: 
			(
				eFileName.text= "ZwrL34R300.inc"
			)
			2:
			(
				eFileName.text= "ZwrP34R300.inc"
			)
		)
	)

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnRadius1.enabled= false
			)
			2:
			(
				spnRadius1.enabled= true
			)
		)
	)

	on btn1 pressed do
	(
		startTool CreateTrack
		
	)
)
